unit DataListF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls, StdCtrls, ComCtrls, PrintTxt, Menus;

type
  TDataListForm = class(TForm)
    Panel1: TPanel;
    StringGrid1: TStringGrid;
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    UpDown1: TUpDown;
    FontDialog1: TFontDialog;
    Button6: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    Button7: TButton;
    UpDown2: TUpDown;
    CheckBox4: TCheckBox;
    Label1: TLabel;
    Edit1: TEdit;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    Button8: TButton;
    procedure FormShow(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure StringGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure StringGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure StringGrid1RowMoved(Sender: TObject; FromIndex,
      ToIndex: Integer);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure UpDown1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure Button4Click(Sender: TObject);
    procedure Panel2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button6Click(Sender: TObject);
    procedure Panel3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button7MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure UpDown2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure CheckBox4Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private 錾 }
    procedure ExchangeItems(I, J: Integer);
    function SCompare(I, J: Integer): Integer;
    procedure QuickSort(L, R: Integer);
  public
    { Public 錾 }
    SortCol: Integer;
    SortOrder: Integer;
    Partition: Integer; // igsȂꍇ̒i
    procedure MoveRow(FromIndex, ToIndex: Integer);
    function Overlapping(var Row1: Integer; var Row2: Integer): Boolean;
    function Search(S: String; Front: Boolean): Boolean;
  end;

var
  DataListForm: TDataListForm;

implementation

uses Frame, Sort, Numbering, Progress;

{$R *.DFM}

procedure TDataListForm.FormShow(Sender: TObject);
var
  i: Integer;
begin
  ProgressForm.Caption := '  f[^̃`FbN  ---  ΂炭҂B';
  if FrameForm.Parameter1.Count > 0 then
  begin
    Left := FrameForm.Parameter1['DLeft'];
    Top := FrameForm.Parameter1['DTop'];
    Width := FrameForm.Parameter1['DWidth'];
    Height := FrameForm.Parameter1['DHeight'];
    WindowState := TWindowState(FrameForm.Parameter1['DWindowState']);
    StringGrid1.Font.Name := FrameForm.Parameter1.VStrings['DFontName'];
    StringGrid1.Font.Size := FrameForm.Parameter1['DFontSize'];
    StringGrid1.Font.Style := FrameForm.Parameter1.VFontStyles['DFontStyle'];
    StringGrid1.Font.Color := TColor(FrameForm.Parameter1['DFontColor']);
    StringGrid1.DefaultRowHeight := FrameForm.Parameter1['DDefaultRowHeight'];
    StringGrid1.ColWidths[1] := FrameForm.Parameter1['DColWidths[1]'];
    StringGrid1.ColWidths[2] := FrameForm.Parameter1['DColWidths[2]'];
    StringGrid1.ColWidths[3] := FrameForm.Parameter1['DColWidths[3]'];
    Partition := FrameForm.Parameter1['DPartition'];
    CheckBox1.Checked := FrameForm.Parameter1.VBools['G^[L[Ŏ̍sɈړ'];
    CheckBox2.Checked := FrameForm.Parameter1.VBools['펞͂̏'];
    CheckBox3.Checked := FrameForm.Parameter1.VBools['G^[L[Ńf[^`FbN'];
    CheckBox4.Checked := FrameForm.Parameter1.VBools['SɈv镶'];
    Edit1.Text := FrameForm.Parameter1.VStrings[''];
  end
  else
    Partition := 1; // igsȂꍇ̒i

  StringGrid1.Canvas.Font := StringGrid1.Font;
  StringGrid1.Invalidate;
  StringGrid1.ColWidths[0] := StringGrid1.Canvas.TextWidth('00000000');

  StringGrid1.RowCount := FrameForm.ComboBox1.Items.Count + 2; // f[^ + 2
  Caption := 'f[^̈ꗗ\  :  ' + IntToStr(StringGrid1.RowCount - 2) + '';
  Panel2.Caption := 'sԊu = ' + IntToStr(StringGrid1.DefaultRowHeight);
  Panel3.Caption := '̒i = ' + IntToStr(Partition);

  StringGrid1.Cells[1, 0] := 'o[R[h';
  StringGrid1.Cells[2, 0] := '㕔̃Rg';
  StringGrid1.Cells[3, 0] := '̃Rg';

  for i := 1 to StringGrid1.RowCount - 1 do
    StringGrid1.Cells[0, i] := IntToStr(i);

  for i := 1 to StringGrid1.RowCount - 2 do
  begin
    StringGrid1.Cells[1, i] := FrameForm.ComboBox1.Items.Strings[i - 1];
    StringGrid1.Cells[2, i] := FrameForm.ComboBox7.Items.Strings[i - 1];
    StringGrid1.Cells[3, i] := FrameForm.ComboBox8.Items.Strings[i - 1];
  end;

  i := FrameForm.ComboBox1.Tag + 1;
  if i = 0 then // f[^Ȃ͂̍Œ̏ꍇ
    i := 1;
  StringGrid1.Row := i;
  StringGrid1.Col := 1;
end;

procedure TDataListForm.StringGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  if (ARow = StringGrid1.RowCount - 1) and (ACol > 1) then
    CanSelect := False;
end;

procedure TDataListForm.StringGrid1SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  if (ARow = StringGrid1.RowCount - 1) and (ACol = 1)
   and (StringGrid1.Cells[ACol, ARow] <> '') then
  begin
    StringGrid1.RowCount := StringGrid1.RowCount + 1;
    StringGrid1.Cells[0, StringGrid1.RowCount - 1] := IntToStr(StringGrid1.RowCount - 1);
    Caption := 'f[^̈ꗗ\  :  ' + IntToStr(StringGrid1.RowCount - 2) + '';
  end;
end;

procedure TDataListForm.StringGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  Row1, Row2: Integer;
  R, C, RC: Integer;
  ol: Boolean;
begin
  if Key <> $0D then
    Exit;

  R := StringGrid1.Row;
  C := StringGrid1.Col;
  RC := StringGrid1.RowCount;
  ol := False;

  if (R < RC - 1) and CheckBox1.Checked then
    StringGrid1.Row := R + 1; // ̍sɈړ

  if (C = 1 ) and ((R = RC - 2) or CheckBox3.Checked) then
    ol := Overlapping(Row1, Row2); // f[^̃`FbN

  if ol = False then
    Exit;

  if Row1 < Row2 then
    ShowMessage(IntTostr(Row1) + 'sڂ ' + IntTostr(Row2)
                + 'sڂ̃f[^dĂ܂B')
  else if Row1 = Row2 then
    ShowMessage(IntTostr(Row2) + 'sڂ̃o[R[h񂪓͂Ă܂B');

  StringGrid1.Row := Row2;
end;

procedure TDataListForm.StringGrid1RowMoved(Sender: TObject; FromIndex,
  ToIndex: Integer);
var
  i: Integer;
begin
  if ToIndex = StringGrid1.RowCount - 1 then // ̍sŌ̍sւ́A
    MoveRow(ToIndex, FromIndex)              // hbO&hbvoȂlɂB
  else if FromIndex = StringGrid1.RowCount - 1 then // Ō̍s瑼̍sւ́A
    MoveRow(ToIndex, FromIndex)              // hbO&hbvoȂlɂB
  else
  begin
    for i := 1 to StringGrid1.RowCount - 1 do
      StringGrid1.Cells[0, i] := IntToStr(i);
  end;
end;

{ FromIndex s ToIndex s̈ʒuֈړ葱łB}
{ }EXŁAFromIndex s ToIndex s̈ʒuֈړꍇ }
{ ܂B}
procedure TDataListForm.MoveRow(FromIndex, ToIndex: Integer);
var
  i: Integer;
  S1, S2, S3: String;
begin
  if (FromIndex < 1) or (FromIndex > StringGrid1.RowCount - 1)
     or (ToIndex < 1) or (ToIndex > StringGrid1.RowCount - 1)
     or (FromIndex = ToIndex) then
    Exit;

  S1 := StringGrid1.Cells[1, FromIndex]; // o[R[h
  S2 := StringGrid1.Cells[2, FromIndex]; // 㕔̃Rg
  S3 := StringGrid1.Cells[3, FromIndex]; // ̃Rg
  if FromIndex < ToIndex then
  begin
     for i := FromIndex to ToIndex - 1 do
     begin
       StringGrid1.Cells[1, i] := StringGrid1.Cells[1, i + 1];
       StringGrid1.Cells[2, i] := StringGrid1.Cells[2, i + 1];
       StringGrid1.Cells[3, i] := StringGrid1.Cells[3, i + 1];
     end;
  end
  else // FromIndex > ToIndex
  begin
     for i := FromIndex downto ToIndex + 1 do
     begin
       StringGrid1.Cells[1, i] := StringGrid1.Cells[1, i - 1];
       StringGrid1.Cells[2, i] := StringGrid1.Cells[2, i - 1];
       StringGrid1.Cells[3, i] := StringGrid1.Cells[3, i - 1];
     end;
  end;
  StringGrid1.Cells[1, ToIndex] := S1;
  StringGrid1.Cells[2, ToIndex] := S2;
  StringGrid1.Cells[3, ToIndex] := S3;

  for i := 1 to StringGrid1.RowCount - 1 do
    StringGrid1.Cells[0, i] := IntToStr(i);
end;

procedure TDataListForm.CheckBox1Click(Sender: TObject);
begin
  StringGrid1.SetFocus;
end;

procedure TDataListForm.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked then
    StringGrid1.Options := StringGrid1.Options + [goAlwaysShowEditor]
  else
    StringGrid1.Options := StringGrid1.Options - [goAlwaysShowEditor];
  StringGrid1.SetFocus;
end;

{ f[^̒ɏdp[R[h̃f[^邩ǂ`FbN }
{ ܂B߂l True ŁARow1 < Row2 łΏdf[^ӖA}
{ Row1 = Row2 ł΋̃f[^Ӗ܂B}
function TDataListForm.Overlapping(var Row1: Integer; var Row2: Integer): Boolean;
var
  i, j, n: Integer;
  gap: Integer;
  C, S: String;
  List: TStringList;
begin
  Result := False;
  n := StringGrid1.RowCount;

  if n <= 3 then
  begin
    if (n = 3) and (StringGrid1.Cells[1, 1] = '') then
    begin // f[^PŁÃV{񂪋̏ꍇ
      Result := True;
      Row1 := 1;
      Row2 := 1;
    end;
    Exit;
  end;

  List := TStringList.Create;
  try
    List.Assign(StringGrid1.Cols[1]);
    gap := (n - 3) div 21 + 1;
    ProgressForm.ProgressBar1.Min := 0;
    ProgressForm.ProgressBar1.Max := 20;
    ProgressForm.ProgressBar1.Step := 1;
    ProgressForm.ProgressBar1.Position := 0;
    ProgressForm.Show;
    for j := n - 2 downto 2 do
    begin
      C := List[j];
      if C = '' then
      begin
        Result := True;
        Row1 := j;
        Row2 := j;
        Break;
      end;
      for i := 1 to j - 1 do
      begin
        S := List[i];
        if S = '' then
        begin
          Result := True;
          Row1 := i;
          Row2 := i;
          Break;
        end;
        if S = C then
        begin
          Result := True;
          Row1 := i;
          Row2 := j;
          Break; // Row1 < Row2
        end;
      end;
      if (j mod gap) = 0 then
        ProgressForm.ProgressBar1.StepIt;
      if Result = True then
        Break;
    end;
    ProgressForm.Close;
  finally
    List.Free;
  end;
end;

procedure TDataListForm.CheckBox3Click(Sender: TObject);
begin
  StringGrid1.SetFocus;
end;

procedure TDataListForm.Button1Click(Sender: TObject);
var
  i: Integer;
  Row1, Row2: Integer;
  ol: Boolean;
begin
  ol := Overlapping(Row1, Row2); // f[^̃`FbN

  if ol = False then // ͂ꂽf[^łB
  begin
    FrameForm.ComboBox1.Items.Clear;
    FrameForm.ComboBox7.Items.Clear;
    FrameForm.ComboBox8.Items.Clear;
    for i := 1 to StringGrid1.RowCount - 2 do
    begin
      FrameForm.ComboBox1.Items.Add(StringGrid1.Cells[1, i]);
      FrameForm.ComboBox7.Items.Add(StringGrid1.Cells[2, i]);
      FrameForm.ComboBox8.Items.Add(StringGrid1.Cells[3, i]);
    end;
    ModalResult := mrOk;
  end
  else
  begin
    if Row1 < Row2 then
      ShowMessage(IntTostr(Row1) + 'sڂ ' + IntTostr(Row2)
                  + 'sڂ̃f[^dĂ܂B')
    else
      ShowMessage(IntTostr(Row2) + 'sڂ̃o[R[h񂪓͂Ă܂B');
    StringGrid1.SetFocus;
    StringGrid1.Row := Row2;
    StringGrid1.Col := 1;
  end;
end;

procedure TDataListForm.Button3Click(Sender: TObject);
var
  i: Integer;
begin
  for i := StringGrid1.Row to StringGrid1.RowCount - 2 do
  begin
    StringGrid1.Cells[1, i] := StringGrid1.Cells[1, i + 1];
    StringGrid1.Cells[2, i] := StringGrid1.Cells[2, i + 1];
    StringGrid1.Cells[3, i] := StringGrid1.Cells[3, i + 1];
  end;
  if (StringGrid1.Row < StringGrid1.RowCount - 1) and (StringGrid1.RowCount > 2) then
  begin
    StringGrid1.Col := 1;
    StringGrid1.RowCount := StringGrid1.RowCount - 1;
    Caption := 'f[^̈ꗗ\  :  ' + IntToStr(StringGrid1.RowCount - 2) + '';
  end;
  StringGrid1.SetFocus;
end;

procedure TDataListForm.ExchangeItems(I, J: Integer);
var
  S: String;
begin
  S := StringGrid1.Cells[1, I];
  StringGrid1.Cells[1, I] := StringGrid1.Cells[1, J];
  StringGrid1.Cells[1, J] := S;
  S := StringGrid1.Cells[2, I];
  StringGrid1.Cells[2, I] := StringGrid1.Cells[2, J];
  StringGrid1.Cells[2, J] := S;
  S := StringGrid1.Cells[3, I];
  StringGrid1.Cells[3, I] := StringGrid1.Cells[3, J];
  StringGrid1.Cells[3, J] := S;
end;

function TDataListForm.SCompare(I, J: Integer): Integer;
begin
  Result := AnsiCompareText(StringGrid1.Cells[SortCol, I],
                            StringGrid1.Cells[SortCol, J]) * SortOrder;
end;

procedure TDataListForm.QuickSort(L, R: Integer);
var
  I, J, P: Integer;
begin
  repeat
    I := L;
    J := R;
    P := (L + R) shr 1;
    repeat
      while SCompare(I, P) < 0 do Inc(I);
      while SCompare(J, P) > 0 do Dec(J);
      if I <= J then
      begin
        ExchangeItems(I, J);
        if P = I then
          P := J
        else if P = J then
          P := I;
        Inc(I);
        Dec(J);
      end;
    until I > J;
    if L < J then QuickSort(L, J);
    L := I;
  until I >= R;
end;

procedure TDataListForm.Button5Click(Sender: TObject);
var
  re: Integer;
begin
  if StringGrid1.RowCount < 4 then
    Exit;

  SortForm := TSortForm.Create(Self);

  re := SortForm.ShowModal;

  SortForm.Free;

  StringGrid1.SetFocus;

  if re <> mrOk then
    Exit;

  SortOrder := FrameForm.SortOrder;

  if FrameForm.SortBox = FrameForm.ComboBox1 then
    SortCol := 1
  else if FrameForm.SortBox = FrameForm.ComboBox7 then
    SortCol := 2
  else if FrameForm.SortBox = FrameForm.ComboBox8 then
    SortCol := 3
  else
    Exit;

  QuickSort(1, StringGrid1.RowCount - 2);
  StringGrid1.Row := 1;
  StringGrid1.Col := 1;
end;

procedure TDataListForm.UpDown1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Abs(UpDown1.Position) > 1000 then
  begin
    UpDown1.Tag := 1;
    UpDown1.Position := 0;
  end;
end;

procedure TDataListForm.UpDown1Click(Sender: TObject; Button: TUDBtnType);
var
  i: Integer;
begin
  if UpDown1.Tag = 1 then
  begin
    UpDown1.Tag := 0;
    Exit;
  end;

  i := StringGrid1.Row;
  if StringGrid1.RowCount < 4 then
    Exit;

  if Button = btNext then
  begin
    if (i > 1) and (i < StringGrid1.RowCount - 1) then
    begin
      ExchangeItems(i - 1, i);
      StringGrid1.Row := i - 1;
    end;
  end
  else if Button = btPrev then
  begin
    if i < StringGrid1.RowCount - 2 then
    begin
      ExchangeItems(i, i + 1);
      StringGrid1.Row := i + 1;
    end;
  end;
end;

procedure TDataListForm.Button4Click(Sender: TObject);
begin
  FontDialog1.Font := StringGrid1.Font;
  if FontDialog1.Execute = True then
  begin
    StringGrid1.Font := FontDialog1.Font;
    StringGrid1.Canvas.Font := FontDialog1.Font;
    StringGrid1.Invalidate;
    StringGrid1.ColWidths[0] := StringGrid1.Canvas.TextWidth('00000000');
  end;
  StringGrid1.SetFocus;
end;

procedure TDataListForm.Panel2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  g: Integer;
begin
  g := 0;
  if ssLeft in Shift then       // }EX̍{^ꂽB
  begin
    if ssShift in Shift then
      g := -4
    else if ssCtrl in Shift then
      g := -3
    else if ssAlt in Shift then
      g := -2
    else
      g := -1;
  end
  else if ssRight in Shift then // }EX̉E{^ꂽB
  begin
    if ssShift in Shift then
      g := 4
    else if ssCtrl in Shift then
      g := 3
    else if ssAlt in Shift then
      g := 2
    else
      g := 1;
  end;

  g := g + StringGrid1.DefaultRowHeight;
  if g < 6 then
    g := 6
  else if g > 80 then
    g := 80;
  StringGrid1.DefaultRowHeight := g;
  Panel2.Caption := 'sԊu = ' + IntToStr(g);
end;

procedure TDataListForm.Button6Click(Sender: TObject);
var
  i: Integer;
  FS: String;
  LS: String;
  DLineSize: Integer;
  DList: TStringList;
begin
  i := StringGrid1.RowCount;
  if i < 100 then
    DLineSize := 2
  else if i < 10000 then
    DLineSize := 4
  else if i < 1000000 then
    DLineSize := 6
  else
    DLineSize := 8;

  FS := '%4d: '; // Format ֐Ŏgp`
  FS[2] := Chr(Abs(DLineSize) + $30); // sԍ̌
  DList := TStringList.Create;
  try
    for i := 1 to StringGrid1.RowCount - 2 do
    begin
      LS := Format(FS, [i]);
      DList.Add(LS + StringGrid1.Cells[2, i]);
      DList.Add(LS + StringGrid1.Cells[1, i]);
      DList.Add(LS + StringGrid1.Cells[3, i]);
    end;
    PrintText(DList.Text,
              'f[^ꗗ',
              StringGrid1.Font,
              8,
              0,
              76,
              76,
              76,
              92,
              Partition,
              32,
              poFileName or poTimeStamp or poPageNumber,
              Font,
              1);
  finally
    DList.Free;
  end;
  StringGrid1.SetFocus;
end;

procedure TDataListForm.Panel3MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  g: Integer;
begin
  g := 0;
  if ssLeft in Shift then       // }EX̍{^ꂽB
  begin
    if ssShift in Shift then
      g := -4
    else if ssCtrl in Shift then
      g := -3
    else if ssAlt in Shift then
      g := -2
    else
      g := -1;
  end
  else if ssRight in Shift then // }EX̉E{^ꂽB
  begin
    if ssShift in Shift then
      g := 4
    else if ssCtrl in Shift then
      g := 3
    else if ssAlt in Shift then
      g := 2
    else
      g := 1;
  end;

  g := g + Partition;
  if g < 1 then
    g := 1
  else if g > 24 then
    g := 24;
  Partition := g;
  Panel3.Caption := '̒i = ' + IntToStr(g);
end;

procedure TDataListForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if (FrameForm.Parameter1.Count = 0) or (WindowState <> wsMaximized) then
  begin
    FrameForm.Parameter1['DLeft'] := Left;
    FrameForm.Parameter1['DTop'] := Top;
    FrameForm.Parameter1['DWidth'] := Width;
    FrameForm.Parameter1['DHeight'] := Height;
  end;
  FrameForm.Parameter1['DWindowState'] := Integer(WindowState);
  FrameForm.Parameter1.VStrings['DFontName'] := StringGrid1.Font.Name;
  FrameForm.Parameter1['DFontSize'] := StringGrid1.Font.Size;
  FrameForm.Parameter1.VFontStyles['DFontStyle'] := StringGrid1.Font.Style;
  FrameForm.Parameter1['DFontColor'] := Integer(StringGrid1.Font.Color);
  FrameForm.Parameter1['DDefaultRowHeight'] := StringGrid1.DefaultRowHeight;
  FrameForm.Parameter1['DColWidths[1]'] := StringGrid1.ColWidths[1];
  FrameForm.Parameter1['DColWidths[2]'] := StringGrid1.ColWidths[2];
  FrameForm.Parameter1['DColWidths[3]'] := StringGrid1.ColWidths[3];
  FrameForm.Parameter1['DPartition'] := Partition;
  FrameForm.Parameter1.VBools['G^[L[Ŏ̍sɈړ'] := CheckBox1.Checked;
  FrameForm.Parameter1.VBools['펞͂̏'] := CheckBox2.Checked;
  FrameForm.Parameter1.VBools['G^[L[Ńf[^`FbN'] := CheckBox3.Checked;
  FrameForm.Parameter1.VBools['SɈv镶'] := CheckBox4.Checked;
  FrameForm.Parameter1.VStrings[''] := Edit1.Text;

  FrameForm.Button14.Tag := StringGrid1.Row - 1;
end;

procedure TDataListForm.Button7MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  R: Integer;
begin
  R := StringGrid1.Row;
  StringGrid1.RowCount := StringGrid1.RowCount + 1;
  StringGrid1.Col := 1;
  if ssCtrl in Shift then
  begin
    MoveRow(StringGrid1.RowCount - 1, R + 1);
    StringGrid1.Cells[1, R + 1] := StringGrid1.Cells[1, R];
    StringGrid1.Cells[2, R + 1] := StringGrid1.Cells[2, R];
    StringGrid1.Cells[3, R + 1] := StringGrid1.Cells[3, R];
    StringGrid1.Row := R + 1;
  end
  else if ssShift in Shift then
  begin
    MoveRow(StringGrid1.RowCount - 1, R);
    StringGrid1.Cells[1, R] := StringGrid1.Cells[1, R + 1];
    StringGrid1.Cells[2, R] := StringGrid1.Cells[2, R + 1];
    StringGrid1.Cells[3, R] := StringGrid1.Cells[3, R + 1];
    StringGrid1.Row := R;
  end
  else if ssAlt in Shift then
  begin
    MoveRow(StringGrid1.RowCount - 1, R + 1);
    StringGrid1.Row := R + 1;
  end
  else
  begin
    MoveRow(StringGrid1.RowCount - 1, R);
    StringGrid1.Row := R;
  end;
  StringGrid1.SetFocus;
  Caption := 'f[^̈ꗗ\  :  ' + IntToStr(StringGrid1.RowCount - 2) + '';
end;

function TDataListForm.Search(S: String; Front: Boolean): Boolean;
var
  i, si: Integer;
  r, c: Integer;
  Whole: Boolean;
  CS: String;
begin
  Result := False;
  r := StringGrid1.Row;
  c := StringGrid1.Col;
  Whole := CheckBox4.Checked;
  if S = '' then
    Whole := True;
  si := (StringGrid1.Row - 1) * 3 + ((StringGrid1.Col - 1) mod 3); // Jnʒu

  if Front then
  begin
    Inc(si); // ݂̃J[\ʒu̎猟JnB
    for i := si to ((StringGrid1.RowCount - 2) * 3) do
    begin
      r := (i div 3) + 1;
      c := (i mod 3) + 1;
      CS := StringGrid1.Cells[c, r];
      if Whole then
      begin
        if CS = S then
          Result := True;
      end
      else
      begin
        if Pos(S, CS) <> 0 then
          Result := True;
      end;
      if Result = True then
        Break;
    end;
  end
  else
  begin
    Dec(si); // ݂̃J[\ʒûPO猟JnB
    for i := si downto 0 do
    begin
      r := (i div 3) + 1;
      c := (i mod 3) + 1;
      CS := StringGrid1.Cells[c, r];
      if Whole then
      begin
        if CS = S then
          Result := True;
      end
      else
      begin
        if Pos(S, CS) <> 0 then
          Result := True;
      end;
      if Result = True then
        Break;
    end;
  end;

  if Result = True then
  begin
    if r = StringGrid1.RowCount - 1 then
    begin
      StringGrid1.Col := c;
      StringGrid1.Row := r;
    end
    else
    begin
      StringGrid1.Row := r;
      StringGrid1.Col := c;
    end;
  end;
end;

procedure TDataListForm.UpDown2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Abs(UpDown2.Position) > 1000 then
  begin
    UpDown2.Tag := 1;
    UpDown2.Position := 0;
  end;
end;

procedure TDataListForm.UpDown2Click(Sender: TObject; Button: TUDBtnType);
var
  Front: Boolean;
begin
  if UpDown2.Tag = 1 then
  begin
    UpDown2.Tag := 0;
    Exit;
  end;

  if Button = btPrev then
    Front := True
  else
    Front := False;

  Search(Edit1.Text, Front);
end;

procedure TDataListForm.CheckBox4Click(Sender: TObject);
begin
  StringGrid1.SetFocus;
end;

procedure TDataListForm.N1Click(Sender: TObject);
var
  S: String;
begin
  S := Edit1.Text;
  if InputQuery('̓', '͂͂ĉB', S) then
  begin
    Edit1.Text := S;
    Search(Edit1.Text, True);
  end;
end;

procedure TDataListForm.N3Click(Sender: TObject);
begin
  Search(Edit1.Text, True);
end;

procedure TDataListForm.N4Click(Sender: TObject);
begin
  Search(Edit1.Text, False);
end;

procedure TDataListForm.N6Click(Sender: TObject);
begin
  StringGrid1.Col := 1;
  StringGrid1.Row := 1;
end;

procedure TDataListForm.N7Click(Sender: TObject);
begin
  StringGrid1.Col := 1;
  StringGrid1.Row := StringGrid1.RowCount - 1;
end;

procedure TDataListForm.Button8Click(Sender: TObject);
var
  re: Integer;
begin
  NumberingForm := TNumberingForm.Create(Self);

  re := NumberingForm.ShowModal;

  NumberingForm.Free;

  StringGrid1.SetFocus;

  if re <> mrOk then
    Exit;

  StringGrid1.Row := 1;
  StringGrid1.Col := 1;

  StringGrid1.SetFocus;
  Caption := 'f[^̈ꗗ\  :  ' + IntToStr(StringGrid1.RowCount - 2) + '';
end;

end.
