unit Preview;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Printers, StdCtrls, Clipbrd, BarImage, jpeg;

type
  TPreviewForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button6: TButton;
    Button7: TButton;
    Button5: TButton;
    SaveDialog1: TSaveDialog;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private 錾 }
    MinFrame: Boolean;
    PageCount: Integer;  // ̃y[W
    Page: Integer;       // \Jny[W
    PageMax: Integer;    // Py[Wɕ\o鐔
    Pbitmap: TBitmap;
  public
    { Public 錾 }
    procedure Preview(p: Integer);
    procedure LPreview(p: Integer);
  end;

var
  PreviewForm: TPreviewForm;

implementation

uses Frame, Progress;

{$R *.DFM}

procedure TPreviewForm.FormShow(Sender: TObject);
var
  i, n: Integer;
  g: Integer;
  row, column: Integer;
  w, h: Integer;                  // v^̃o[R[hP̑傫(sNZP)
  pxi, pyi: Integer;              // v^̂PC`̃sNZ
  sxi, syi: Integer;              // XN[̂PC`̃sNZ
  ppwidth, ppheight: Integer;     // v^p̑傫(sNZP)
  pwidth, pheight: Integer;       // v^p̈\̈̑傫(sNZP)
  leftmargin, topmargin: Integer; // v^p̍Ə̗](sNZP)
  gapwidth, gapheight: Integer;   // ̗ԊuyэsԊu(sNZP)
  startx, starty: Integer;        // v^p̈\̈ɂJn_(sNZP)
  r: Integer;                     // ̔{(%)
  rr: Integer;                    // v^p̑傫ɑ΂XN[̃vr[ʂ̑傫̔䗦(%)
begin
  ProgressForm.Caption := '  ܌vZłB---  ΂炭҂B';
  FrameForm.PaperInfo := FrameForm.CollectPaperInfo; // ݂̎𓾂B

  if FrameForm.BarImage1.BarFrame = 1 then
  begin
    MinFrame := True;
    FrameForm.BarImage1.BarFrame := 2;
  end
  else
    MinFrame := False;

  pxi := FrameForm.PaperInfo.DPI.cx;
  FrameForm.pxi := pxi;
  pyi := FrameForm.PaperInfo.DPI.cy;
  FrameForm.pyi := pyi;
  sxi := GetDeviceCaps(Canvas.Handle, LOGPIXELSX);
  FrameForm.sxi := sxi;
  syi := GetDeviceCaps(Canvas.Handle, LOGPIXELSY);
  FrameForm.syi := syi;
  ppwidth := FrameForm.PaperInfo.PaperSize.Width;
  FrameForm.ppwidth := ppwidth;
  ppheight := FrameForm.PaperInfo.PaperSize.Height;
  FrameForm.ppheight := ppheight;
  pwidth := FrameForm.PaperInfo.PrintableArea.Width;
  FrameForm.pwidth := pwidth;
  pheight := FrameForm.PaperInfo.PrintableArea.Height;
  FrameForm.pheight := pheight;
  leftmargin := FrameForm.PaperInfo.LeftMargin;
  FrameForm.leftmargin := leftmargin;
  topmargin := FrameForm.PaperInfo.TopMargin;
  FrameForm.topmargin := topmargin;
  gapwidth := FrameForm.gapwidth;
  gapheight := FrameForm.gapheight;
  startx := FrameForm.startx;
  starty := FrameForm.starty;

  r := FrameForm.UpDown8.Position; // ̔{(%)
  w := ((FrameForm.BarImage1.Width * pxi * r) div sxi) div 100;
  h := ((FrameForm.BarImage1.Height * pyi * r) div syi) div 100;

  { ̗񐔂߂B}
  column := 0;
  n := pwidth - startx;
  while n > 0 do
  begin
    if n >= w then
      Inc(column);
    Dec(n, w + gapwidth);
  end;
  if column = 0 then
    column := 1;

  { ̍s߂B}
  row := 0;
  n := pheight - starty;
  while n > 0 do
  begin
    if n >= h then
      Inc(row);
    Dec(n, h + gapheight);
  end;
  if row = 0 then
    row := 1;

  PageMax := row * column; // Py[Wɕ\o鐔

  n := FrameForm.UpDown7.Position;

  if FrameForm.plist = True then
  begin
    PageCount := 10000;
    Caption := 'Xgvr[  :  ' + IntToStr(FrameForm.nlist) + '';
  end
  else
  begin
    PageCount := n div (row * column); // ̃y[W
    if n mod (row * column) <> 0 then
      Inc(PageCount);
    Caption := 'vr[  :  ' + IntToStr(n) + '';
  end;

  Page := 1; // vr[\Jny[W
  g := 5; // XN[̂TsNZ

  { ŁAv^p̑傫ɑ΂XN[ }
  { vr[ʂ̑傫̔䗦(%)߂܂B}
  rr := ((Screen.Width * 99) div ppwidth) div 2;
  i := (Screen.Height * 80) div ppheight;
  if i < rr then
    rr := i;

  ClientWidth := (ppwidth * 2 * rr) div 100 + g * 3;
  ClientHeight := Panel1.Height + (ppheight * rr) div 100 + g * 2;
  Image1.Picture.Bitmap.Width := Image1.Width;
  Image1.Picture.Bitmap.Height := Image1.Height;
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.FillRect(Rect(0, 0, Image1.Width, Image1.Height));
  Label2.Left := (ppwidth * rr) div 100 + g * 2;

  Pbitmap.Width := (pwidth * rr) div 100;
  Pbitmap.Height := (pheight * rr) div 100;
  Pbitmap.Canvas.Brush.Color := clWhite;
  Pbitmap.Canvas.Brush.Style := bsSolid;
  Pbitmap.Canvas.FillRect(Rect(0, 0, Pbitmap.Width, Pbitmap.Height));

  if (FrameForm.slist = True) and (r = ((100 * 100 * sxi) div rr) div pxi) then
    Button5.Enabled := False
  else
  begin
    Button5.Enabled := True;
    FrameForm.slist := False;
  end;

  if FrameForm.plist = True then
    LPreview(Page)
  else
    Preview(Page);
end;

procedure TPreviewForm.Preview(p: Integer);
var
  i, j, n, count, pg: Integer;
  g: Integer;
  row, column: Integer;
  w, h: Integer;                  // v^̃o[R[hP̑傫(sNZP)
  pxi, pyi: Integer;              // v^̂PC`̃sNZ
  sxi, syi: Integer;              // XN[̂PC`̃sNZ
  ppwidth, ppheight: Integer;     // v^p̑傫(sNZP)
  pwidth, pheight: Integer;       // v^p̈\̈̑傫(sNZP)
  leftmargin, topmargin: Integer; // v^p̍Ə̗](sNZP)
  gapwidth, gapheight: Integer;   // ̗ԊuyэsԊu(sNZP)
  startx, starty: Integer;        // v^p̈\̈ɂJn_(sNZP)
  r: Integer;                     // ̔{(%)
  rr: Integer;                    // v^p̑傫ɑ΂XN[̃vr[ʂ̑傫̔䗦(%)
  xx: Integer;
  graphic:TGraphic;
begin
  if (p < 1) or (p > PageCount) then
    Exit;

  pxi := FrameForm.pxi;
  pyi := FrameForm.pyi;
  sxi := FrameForm.sxi;
  syi := FrameForm.syi;
  ppwidth := FrameForm.ppwidth;
  ppheight := FrameForm.ppheight;
  pwidth := FrameForm.pwidth;
  pheight := FrameForm.pheight;
  leftmargin := FrameForm.leftmargin;
  topmargin := FrameForm.topmargin;
  gapwidth := FrameForm.gapwidth;
  gapheight := FrameForm.gapheight;
  startx := FrameForm.startx;
  starty := FrameForm.starty;

  r := FrameForm.UpDown8.Position; // ̔{(%)
  w := ((FrameForm.BarImage1.Width * pxi * r) div sxi) div 100;
  h := ((FrameForm.BarImage1.Height * pyi * r) div syi) div 100;

  { ̗񐔂߂B}
  column := 0;
  n := pwidth - startx;
  while n > 0 do
  begin
    if n >= w then
      Inc(column);
    Dec(n, w + gapwidth);
  end;
  if column = 0 then
    column := 1;

  { ̍s߂B}
  row := 0;
  n := pheight - starty;
  while n > 0 do
  begin
    if n >= h then
      Inc(row);
    Dec(n, h + gapheight);
  end;
  if row = 0 then
    row := 1;

  g := 5; // XN[̂TsNZ

  { ŁAv^p̑傫ɑ΂XN[ }
  { vr[ʂ̑傫̔䗦(%)߂܂B}
  rr := ((Screen.Width * 99) div ppwidth) div 2;
  i := (Screen.Height * 80) div ppheight;
  if i < rr then
    rr := i;

  leftmargin := (leftmargin * rr) div 100;
  topmargin := (topmargin * rr) div 100;
  gapwidth := (gapwidth * rr) div 100;
  gapheight := (gapheight * rr) div 100;
  startx := (startx * rr) div 100;
  starty := (starty * rr) div 100;
  w := (w * rr) div 100;
  h := (h * rr) div 100;

  if FrameForm.BarImage1.BarPicture = picBMP then
    graphic := FrameForm.BarImage1.Picture.Bitmap
  else
    graphic := FrameForm.BarImage1.Picture.Metafile;

  Image1.Canvas.FillRect(Rect(0, 0, Image1.Width, Image1.Height));

  Label1.Caption := '';
  Label2.Caption := '';

  n := FrameForm.UpDown7.Position;
  count := (p + 1) * PageMax;
  if count > n then
    count := n;
  ProgressForm.ProgressBar1.Min := 0;
  ProgressForm.ProgressBar1.Max := count;
  ProgressForm.ProgressBar1.Step := 1;
  ProgressForm.ProgressBar1.Position := 0;
  ProgressForm.Show;
  count := 0;
  pg := 1;
  while count < n do
  begin
    if pg = p then
    begin
      xx := 0;
      Label1.Caption := IntToStr(pg) + 'y[W';
    end
    else if pg = p + 1 then
    begin
      xx := (ppwidth * rr) div 100 + g;
      Label2.Caption := IntToStr(pg) + 'y[W';
    end
    else
      xx := -1;

    for j := 0 to row - 1 do
    begin
      for i := 0 to column - 1 do
      begin
        if xx <> -1 then
          Pbitmap.Canvas.StretchDraw(Rect(i * (w + gapwidth) + startx,
                                          j * (h + gapheight) + starty,
                                          i * (w + gapwidth) + w + startx,
                                          j * (h + gapheight) + h + starty),
                                          graphic);
        Inc(count);
        ProgressForm.ProgressBar1.StepIt;
        if count = n then
          Break;
      end;
      if count = n then
        Break;
    end;
    if xx <> -1 then
    begin
      Image1.Canvas.StretchDraw(Rect(g + leftmargin + xx,
                                     g + topmargin,
                                     g + leftmargin + xx + Pbitmap.Width,
                                     g + topmargin + Pbitmap.Height), Pbitmap);

      Pbitmap.Canvas.FillRect(Rect(0, 0, Pbitmap.Width, Pbitmap.Height));

      Image1.Canvas.Brush.Color := clBlack;
      if pg = p then
        Image1.Canvas.FrameRect(Rect(g,
                                     g,
                                     (ppwidth * rr) div 100 + g,
                                     (ppheight * rr) div 100 + g))
      else if pg = p + 1 then
        Image1.Canvas.FrameRect(Rect((ppwidth * rr) div 100 + g * 2,
                                     g,
                                     (ppwidth * 2 * rr) div 100 + g * 2,
                                     (ppheight * rr) div 100 + g));
      Image1.Canvas.Brush.Color := clWhite;
    end;
    if count = n then
      Break;

    Inc(pg);
    if pg > p + 1 then
      Break;
  end;
  ProgressForm.Close;

  Page := p;                 // ݁A\̃y[W
  if Page = 1 then
    Button3.Enabled := False
  else
    Button3.Enabled := True;
  if Page < PageCount - 1 then
    Button4.Enabled := True
  else
    Button4.Enabled := False;
end;

procedure TPreviewForm.Button3Click(Sender: TObject);
begin
  if FrameForm.plist = True then
    LPreview(Page - 1)
  else
    Preview(Page - 1);
end;

procedure TPreviewForm.Button4Click(Sender: TObject);
begin
  if FrameForm.plist = True then
    LPreview(Page + 1)
  else
    Preview(Page + 1);
end;

procedure TPreviewForm.FormCreate(Sender: TObject);
begin
  Pbitmap := TBitmap.Create;
end;

procedure TPreviewForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  Pbitmap.Free;

  if MinFrame = True then
    FrameForm.BarImage1.BarFrame := 1;
end;

procedure TPreviewForm.LPreview(p: Integer);
var
  x, y, n, count, pg: Integer;
  hmax: Integer;
  g: Integer;
  row, column: Integer;
  w, h: Integer;                  // v^̃o[R[hP̑傫(sNZP)
  pxi, pyi: Integer;              // v^̂PC`̃sNZ
  sxi, syi: Integer;              // XN[̂PC`̃sNZ
  ppwidth, ppheight: Integer;     // v^p̑傫(sNZP)
  pwidth, pheight: Integer;       // v^p̈\̈̑傫(sNZP)
  leftmargin, topmargin: Integer; // v^p̍Ə̗](sNZP)
  gapwidth, gapheight: Integer;   // ̗ԊuyэsԊu(sNZP)
  startx, starty: Integer;        // v^p̈\̈ɂJn_(sNZP)
  r: Integer;                     // ̔{(%)
  rr: Integer;                    // v^p̑傫ɑ΂XN[̃vr[ʂ̑傫̔䗦(%)
  xx: Integer;
  graphic:TGraphic;
begin
  if (p < 1) or (p > PageCount) then
    Exit;

  pxi := FrameForm.pxi;
  pyi := FrameForm.pyi;
  sxi := FrameForm.sxi;
  syi := FrameForm.syi;
  ppwidth := FrameForm.ppwidth;
  ppheight := FrameForm.ppheight;
  pwidth := FrameForm.pwidth;
  pheight := FrameForm.pheight;
  leftmargin := FrameForm.leftmargin;
  topmargin := FrameForm.topmargin;
  gapwidth := FrameForm.gapwidth;
  gapheight := FrameForm.gapheight;
  startx := FrameForm.startx;
  starty := FrameForm.starty;

  r := FrameForm.UpDown8.Position;

  g := 5; // XN[̂TsNZ

  { ŁAv^p̑傫ɑ΂XN[ }
  { vr[ʂ̑傫̔䗦(%)߂܂B}
  rr := ((Screen.Width * 99) div ppwidth) div 2;
  x := (Screen.Height * 80) div ppheight;
  if x < rr then
    rr := x;

  Image1.Canvas.FillRect(Rect(0, 0, Image1.Width, Image1.Height));

  Label1.Caption := '';
  Label2.Caption := '';

  n := FrameForm.ComboBox1.Items.Count;
  count := (p + 1) * PageMax;
  if count > n then
    count := n;
  ProgressForm.ProgressBar1.Min := 0;
  ProgressForm.ProgressBar1.Max := count;
  ProgressForm.ProgressBar1.Step := 1;
  ProgressForm.ProgressBar1.Position := 0;
  ProgressForm.Show;
  count := 0;
  pg := 1;
  while count < n do
  begin
    if pg = p then
    begin
      xx := 0;
      Label1.Caption := IntToStr(pg) + 'y[W';
    end
    else if pg = p + 1 then
    begin
      xx := (ppwidth * rr) div 100 + g;
      Label2.Caption := IntToStr(pg) + 'y[W';
    end
    else
      xx := -1;

    y := starty;
    while y < pheight do
    begin
      x := startx;
      hmax := 0;
      while x < pwidth do
      begin
        FrameForm.BarImage1.BarEnabled := False;
        FrameForm.BarImage1.CommentUp := FrameForm.ComboBox7.Items.Strings[count];
        FrameForm.BarImage1.CommentDown := FrameForm.ComboBox8.Items.Strings[count];
        FrameForm.BarImage1.Code := FrameForm.ComboBox1.Items.Strings[count];
        FrameForm.BarImage1.BarEnabled := True;
        if FrameForm.BarImage1.BarDisped = True then
        begin
          w := ((FrameForm.BarImage1.Width * pxi * r) div sxi) div 100;
          h := ((FrameForm.BarImage1.Height * pyi * r) div syi) div 100;
          if (x > 0) and (x + w > pwidth) then
            Break;
          if (y > 0) and (y + h > pheight) then
          begin
            hmax := h;
            Break;
          end;
          if xx <> -1 then
          begin
            if FrameForm.BarImage1.BarPicture = picBMP then
              graphic := FrameForm.BarImage1.Picture.Bitmap
            else
              graphic := FrameForm.BarImage1.Picture.Metafile;
            Pbitmap.Canvas.StretchDraw(Rect((x * rr) div 100,
                                            (y * rr) div 100,
                                            ((x + w) * rr) div 100,
                                            ((y + h) * rr) div 100), graphic);
          end;
          x := x + w + gapwidth;
          if h > hmax then
            hmax := h;
          if ProgressForm.ProgressBar1.Position < ProgressForm.ProgressBar1.Max then
          ProgressForm.ProgressBar1.StepIt;
        end;
        Inc(count);
        if count = n then
          Break;
      end;
      y := y + hmax + gapheight;
      if count = n then
        Break;
    end;
    if xx <> -1 then
    begin
      Image1.Canvas.StretchDraw(Rect(g + (leftmargin * rr) div 100 + xx,
                                     g + (topmargin * rr) div 100,
                                     g + (leftmargin * rr) div 100 + xx + Pbitmap.Width,
                                     g + (topmargin * rr) div 100 + Pbitmap.Height), Pbitmap);

      Pbitmap.Canvas.FillRect(Rect(0, 0, Pbitmap.Width, Pbitmap.Height));

      Image1.Canvas.Brush.Color := clBlack;
      if pg = p then
        Image1.Canvas.FrameRect(Rect(g,
                                     g,
                                     (ppwidth * rr) div 100 + g,
                                     (ppheight * rr) div 100 + g))
      else if pg = p + 1 then
        Image1.Canvas.FrameRect(Rect((ppwidth * rr) div 100 + g * 2,
                                     g,
                                     (ppwidth * 2 * rr) div 100 + g * 2,
                                     (ppheight * rr) div 100 + g));
      Image1.Canvas.Brush.Color := clWhite;
    end;
    if count = n then
      Break;

    Inc(pg);
    if pg > p + 1 then
      Break;
  end;
  ProgressForm.Close;

  if count = n then
    PageCount := pg;

  Page := p;          // ݁A\̃y[W
  if Page = 1 then
    Button3.Enabled := False
  else
    Button3.Enabled := True;
  if Page < PageCount - 1 then
    Button4.Enabled := True
  else
    Button4.Enabled := False;
end;

procedure TPreviewForm.Button5Click(Sender: TObject);
var
  r: Integer;      // ̔{(%P)
  rr, i: Integer;
begin
  { ŁAv^p̑傫ɑ΂XN[ }
  { vr[ʂ̑傫̔䗦(%)߂܂B}
  rr := ((Screen.Width * 99) div FrameForm.ppwidth) div 2;
  i := (Screen.Height * 80) div FrameForm.ppheight;
  if i < rr then
    rr := i;

  r := ((100 * 100 * FrameForm.sxi) div rr) div FrameForm.pxi;

  FrameForm.UpDown8.Position := r;
  FrameForm.slist := True;

  FormShow(Sender);
end;

procedure TPreviewForm.Button6Click(Sender: TObject);
begin
  Clipboard.Assign(Image1.Picture);
end;

procedure TPreviewForm.Button7Click(Sender: TObject);
var
  Ext: String;
  Jpeg: TJPEGImage;
begin
  SaveDialog1.FileName := 'Preview.bmp';

  if SaveDialog1.Execute = True then
  begin
    Ext := LowerCase(ExtractFileExt(SaveDialog1.FileName));
    if (Ext = '.jpg') or (Ext = '.jpeg') then
    begin
      Jpeg := TJPEGImage.Create;
      try
        Jpeg.Assign(Image1.Picture.Bitmap);
        Jpeg.SaveToFile(SaveDialog1.Filename);
      finally
        Jpeg.Free;
      end;
    end
    else
      Image1.Picture.SaveToFile(SaveDialog1.FileName);
  end;
end;

end.
